#install another clock
scoreboard players add @e[name=Global] gameTime 1

#misc
execute if entity @e[name=Global,scores={gameTime=1}] run effect clear @a[team=scapers] resistance
execute if entity @e[name=Global,scores={gameTime=1}] run scoreboard players set @a[team=scapers] fly 0
execute if entity @e[name=Global,scores={gameTime=1}] run scoreboard players reset @e[name=Global] pregame
execute if entity @e[name=Global,scores={gameTime=1}] run scoreboard players reset @e[name=Global] endgame
execute if entity @e[name=Global,scores={gameTime=1}] run scoreboard objectives setdisplay sidebar lives
execute if entity @e[name=Global,scores={gameTime=1}] run scoreboard players operation @a[team=scapers] lives = @e[name=Global] livesCount
execute if entity @e[name=Global,scores={gameTime=1}] run tag @a remove immunity
execute if entity @e[name=Global,scores={gameTime=1}] as @a[team=scapers] run scoreboard players add @e[name=Global] totalScapers 1
execute if entity @e[name=Global,scores={gameTime=1}] as @a[team=scapers] run tag @s add alive
execute if entity @e[name=Global,scores={gameTime=1}] run team modify scapers nametagVisibility hideForOtherTeams

#setup scapers (immunity + titles)
execute if entity @e[name=Global,scores={gameTime=1}] as @a[team=scapers] run tp @s @e[tag=teleport,sort=random,limit=1]
execute if entity @e[name=Global,scores={gameTime=1}] as @a[team=scapers] positioned as @e[tag=teleport,sort=random,limit=1] run spawnpoint @s ~ ~ ~
execute if entity @e[name=Global,scores={gameTime=59}] as @e[team=scapers] run tag @s add immune
execute if entity @e[name=Global,scores={gameTime=59..}] run function skyscapers:gamemodes/snipers/immunity
execute if entity @e[name=Global,scores={gameTime=59..}] as @a[team=scapers,tag=!immunity] unless entity @a[tag=blinded] run effect give @s glowing 100000 255 true
execute if entity @e[name=Global,scores={gameTime=59..}] if entity @a[tag=blinded] run effect clear @a glowing
execute if entity @e[name=Global,scores={gameTime=59}] run replaceitem entity @a[team=scapers] armor.chest minecraft:elytra{display:{Name:'{"text":"Wings","color":"reset","bold":true}',Lore:['{"text":"Keep these on your back!","color":"aqua","italic":true}']},Unbreakable:1b}
execute if entity @e[name=Global,scores={gameTime=59}] as @a[team=scapers] run replaceitem entity @s hotbar.3 minecraft:firework_rocket{display:{Name:'{"text":"Booster","color":"gold","bold":true}',Lore:['{"text":"Right-click to launch!","color":"aqua","italic":true}']}}
execute if entity @e[name=Global,scores={gameTime=59..}] run function skyscapers:gamemodes/snipers/keepelytra
execute if entity @e[name=Global,scores={gameTime=59..}] run scoreboard players set @e[name=Global] scaperCheck 0
execute if entity @e[name=Global,scores={gameTime=59..}] as @a[team=scapers] run scoreboard players add @e[name=Global] scaperCheck 1

#death / boundaries
execute as @a[scores={deaths=1..}] run function skyscapers:gamemodes/snipers/respawn
effect give @a night_vision 100000 255 true
effect give @a saturation 100000 255 true
execute as @e[type=armor_stand,tag=center] at @s as @a[team=spectator,distance=106..] run tp @s -217 32 574
execute as @a[team=spectator,x=-354,y=3,z=445,dx=300,dy=1,dz=300] run tp @s -217 32 574

#setup scapers (initializing)
execute if entity @e[name=Global,scores={gameTime=59}] run effect clear @a blindness
execute if entity @e[name=Global,scores={gameTime=59}] run effect clear @a slowness
execute if entity @e[name=Global,scores={gameTime=59}] run effect clear @a jump_boost
execute if entity @e[name=Global,scores={gameTime=59}] run effect clear @a resistance
execute if entity @e[name=Global,scores={gameTime=19}] as @a[team=scapers] at @s run playsound minecraft:block.note_block.bell master @s ~ ~ ~ 1 1
execute if entity @e[name=Global,scores={gameTime=9}] as @a[team=scapers] at @s run title @s times 0 100 40
execute if entity @e[name=Global,scores={gameTime=19}] as @a[team=scapers] at @s run title @s title {"text":" \u2505","bold":true,"color":"dark_gray"}
execute if entity @e[name=Global,scores={gameTime=39}] as @a[team=scapers] at @s run playsound minecraft:block.note_block.bell master @s ~ ~ ~ 1 2
execute if entity @e[name=Global,scores={gameTime=39}] as @a[team=scapers] at @s run title @s title {"text":" \u2505","bold":true,"color":"dark_gray"}
execute if entity @e[name=Global,scores={gameTime=39}] as @a[team=scapers] at @s run title @s subtitle {"text":" ","color":"dark_gray"}
execute if entity @e[name=Global,scores={gameTime=59}] as @a[team=scapers] at @s run playsound minecraft:entity.player.levelup master @s ~ ~ ~ 1 1
execute if entity @e[name=Global,scores={gameTime=59}] as @a[team=scapers] at @s run title @s times 0 60 0
execute if entity @e[name=Global,scores={gameTime=59}] as @a[team=scapers] at @s run title @s title {"text":"\u2714 Go!","bold":true,"color":"green"}
execute if entity @e[name=Global,scores={gameTime=58}] as @a[team=scapers,tag=stick_wand] run replaceitem entity @s hotbar.4 minecraft:purple_carpet{display:{Name:'{"text":"Broken Stick","color":"#381C01","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @e[name=Global,scores={gameTime=58}] as @a[team=scapers,tag=emerald_wand] run replaceitem entity @s hotbar.4 minecraft:pink_carpet{display:{Name:'{"text":"Emerald Staff","color":"dark_green","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @e[name=Global,scores={gameTime=58}] as @a[team=scapers,tag=toy_wand] run replaceitem entity @s hotbar.4 minecraft:yellow_carpet{display:{Name:'{"text":"Banana Blaster","color":"yellow","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @e[name=Global,scores={gameTime=58}] as @a[team=scapers,tag=magic_wand] run replaceitem entity @s hotbar.4 minecraft:magenta_carpet{display:{Name:'{"text":"Magic Wand","color":"white","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @e[name=Global,scores={gameTime=58}] as @a[team=scapers,tag=book_wand] run replaceitem entity @s hotbar.4 minecraft:orange_carpet{display:{Name:'{"text":"Book of Spells","color":"dark_gray","bold":true}',Lore:['{"text":"Right-click to use!","color":"red","italic":true}']}}
execute if entity @e[name=Global,scores={gameTime=58}] as @a[team=scapers] run replaceitem entity @s weapon.offhand minecraft:carrot_on_a_stick{display:{Name:'{"text":" ","color":"black","bold":true}'}}
execute if entity @e[name=Global,scores={gameTime=59..}] as @a[team=scapers] run function skyscapers:gamemodes/snipers/scaper_loop

#wand cooldown
execute if entity @e[name=Global,scores={gameTime=59..}] run scoreboard players add @a[team=scapers,tag=clickWand,tag=!no_cooldown] wandTime 1

#powerups
execute if entity @e[name=Global,scores={gameTime=59..}] run function skyscapers:gamemodes/snipers/powerup_loop
scoreboard players add @e[name=Global] seekTime 1
execute if entity @e[name=Global,scores={seekTime=20}] run scoreboard players add @e[name=Global] timer 1
execute if entity @e[name=Global,scores={seekTime=20}] run scoreboard players set @e[name=Global] seekTime 0

scoreboard players operation @e[name=Global] check_powerup = @e[name=Global] timer
scoreboard players operation @e[name=Global] check_powerup %= @e[name=Global] global_30
execute unless entity @e[name=Global,scores={gameTime=..70}] if entity @e[name=Global,scores={seekTime=1,check_powerup=0}] run function skyscapers:gamemodes/snipers/spawn_powerup
execute unless entity @e[name=Global,scores={powerup_summoned=6}] unless entity @e[name=Global,scores={gameTime=..70}] if entity @e[tag=powerup_stand,tag=!regeneration,tag=!invulnerability,tag=!absorption,tag=!blindness,tag=!nausea,tag=!destroy_wand,tag=!boost,tag=!no_cooldown,tag=!one_shot] run function skyscapers:gamemodes/snipers/assign_powerup

#end game
execute if entity @e[name=Global,scores={gameTime=41..,scaperCheck=..1}] run scoreboard players add @e[name=Global] delay 1
execute if entity @e[name=Global,scores={gameTime=41..,scaperCheck=..1}] run effect give @a[team=scapers] resistance 100000 255 true
execute if entity @e[name=Global,scores={gameTime=41..,scaperCheck=..1,delay=20}] run scoreboard players set @e[name=Global] gameState 5